import React, { MutableRefObject } from 'react';
import { GenericEmbed } from '../utils';
type InitializerComponentBaseProps = {
    id: string;
    embedRef?: MutableRefObject<GenericEmbed | undefined>;
};
export type InitializerComponentProps<T> = T & InitializerComponentBaseProps;
type CreateFnProps<T> = Omit<InitializerComponentProps<T>, keyof InitializerComponentBaseProps>;
type CreateFn<T> = (id: string, props: CreateFnProps<T>) => GenericEmbed;
declare function makeInitializerComponent<T>(createFn: CreateFn<T>, cssFilename: string): ({ id, embedRef, ...props }: InitializerComponentProps<T>) => React.JSX.Element;
export { makeInitializerComponent };
//# sourceMappingURL=make-initializer-component.d.ts.map